/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumFrameType;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
* This item class contains the methods to set, get and validate the attribute present in PET Frame Correction Factors Sequence.
 */

public class PETFrameCorrectionFactorsSequenceItem extends Item
{
	


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item with default TransferSyntax 
	 */
	PETFrameCorrectionFactorsSequenceItem()
	{
		super();
	}

	/*
	 * This constructor calls the respective superclass constructor
	 * This constructor should throw exception if null TS is tried to be set
	 */
	/**
	 * This constructor creates the item with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	PETFrameCorrectionFactorsSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates PETFrameCorrectionFactorsSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	PETFrameCorrectionFactorsSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/*
	 * (non-Javadoc) This method validates the contents of the Item
	 * @see cdac.medinfo.sdk.dcm30_04.commoninterface.IItem#validate()
	 */
	/**
	 * Validates all the attributes in PETFrameCorrectionFactorsSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try{
			if(getDataForTag(0x0008, 0x9007).getValue().equals(EnumFrameType.Value1.ORIGINAL)){
				if(!contains(0x0054,0x1310))
					throw new MandatoryMissingException("0x0054,0x1310");
				if(!contains(0x0054,0x1320))
					throw new MandatoryMissingException("0x0054,0x1320");
				if(!contains(0x0054,0x1323))
					throw new MandatoryMissingException("0x0054,0x1323");
				if(!contains(0x0054,0x1324))
					throw new MandatoryMissingException("0x0054,0x1324");
			}			
		}
		catch(MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		return true;
	}
	
	/**
	 * Sets Primary Prompts Counts Accumulated.
	 * @param strPrimaryPromptsCountsAccumulated String value of Primary Prompts Counts Accumulated.
	 */
	public void setPrimaryPromptsCountsAccumulated(String strPrimaryPromptsCountsAccumulated )
	{
		/*Accept the Primary Prompts Counts Accumulated in String format of type IS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054,0x1310, strPrimaryPromptsCountsAccumulated ,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0054,0x1310,DicomConstants.DCM_DT_IS, strPrimaryPromptsCountsAccumulated );

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Primary Prompts Counts Accumulated.
	 * @return String - value of Primary Prompts Counts Accumulated.
	 */
	public String getPrimaryPromptsCountsAccumulated()
	{
		Object objValue = getValue(0x0054,0x1310);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Slice Sensitivity Factor.
	 * @param strSliceSensitivityFactor String value of Slice Sensitivity Factor.
	 */
	public void setSliceSensitivityFactor(String strSliceSensitivityFactor)
	{
		/*Accept the Slice Sensitivity Factor in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054,0x1320, strSliceSensitivityFactor,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0054,0x1320,DicomConstants.DCM_DT_DS, strSliceSensitivityFactor);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Slice Sensitivity Factor.
	 * @return String - value of Slice Sensitivity Factor.
	 */
	public String getSliceSensitivityFactor()
	{
		Object objValue = getValue(0x0054,0x1320);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Decay Factor.
	 * @param strDecayFactor String value of Decay Factor.
	 */
	public void setDecayFactor(String strDecayFactor)
	{
		/*Accept the Decay Factor in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054,0x1321, strDecayFactor,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0054,0x1321,DicomConstants.DCM_DT_DS, strDecayFactor);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Decay Factor.
	 * @return String - value of Decay Factor.
	 */
	public String getDecayFactor()
	{
		Object objValue = getValue(0x0054,0x1321);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Scatter Fraction Factor.
	 * @param strScatterFractionFactor String value of Scatter Fraction Factor.
	 */
	public void setScatterFractionFactor(String strScatterFractionFactor)
	{
		/*Accept the Scatter Fraction Factor in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054,0x1323, strScatterFractionFactor,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0054,0x1323,DicomConstants.DCM_DT_DS, strScatterFractionFactor);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Scatter Fraction Factor.
	 * @return String - value of Scatter Fraction Factor.
	 */
	public String getScatterFractionFactor()
	{
		Object objValue = getValue(0x0054,0x1323);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Dead Time Factor.
	 * @param strDeadTimeFactor String value of Dead Time Factor.
	 */
	public void setDeadTimeFactor(String strDeadTimeFactor)
	{
		/*Accept the Dead Time Factor in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054,0x1324, strDeadTimeFactor,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0054,0x1324,DicomConstants.DCM_DT_DS, strDeadTimeFactor);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Dead Time Factor.
	 * @return String - value of Dead Time Factor.
	 */
	public String getDeadTimeFactor()
	{
		Object objValue = getValue(0x0054,0x1324);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

}
